moSetGetGuiMenue = {};

function moSetGetGuiMenue:getNewPullDownTable(int, lineSelect, whichPDA, colorName)
	local whichSubPDA = whichPDA or "masterPDA_";
	local lineCmdTable = {};
	if int == 1 then --PDA SettingLine ....PDA_ -------free
		for a=1, #moSetGetOverlays.pda[whichSubPDA].line do
			lineCmdTable[a] = {};
			lineCmdTable[a].cmdTable = nil;
			lineCmdTable[a].cmdValue = nil;
			lineCmdTable[a].cmdType = "stringOnly";
			lineCmdTable[a].buttonTxt = "Select Line ".. tostring(a);
			lineCmdTable[a].isSelect = a == (lineSelect or 1);
			if a == 1 then 
				lineCmdTable[a].infoTxt = "!! Warning !! Delete line is irrevocable, with(incl.) all Apps Settings. This Line (1) can not be deleted";	
			else
				lineCmdTable[a].infoTxt = "!! Warning !! Delete line is irrevocable, with(incl.) all Apps Settings.";
			end;
		end;		
	elseif int == 2 then --Global PDA Namen
		for _index, name in pairs(moSetGetOverlays.pdaNamen.suggestion) do		
			lineCmdTable[_index] = {};
			lineCmdTable[_index].cmdTable = nil;
			lineCmdTable[_index].cmdValue = nil;
			lineCmdTable[_index].cmdType = "stringOnly";
			lineCmdTable[_index].buttonTxt = tostring(moSetGetOverlays.pdaNamen.suggestion[_index]);
			lineCmdTable[_index].isSelect = _index == 1;		
			lineCmdTable[_index].infoTxt = "! INFO ! the name is used for better finding (for Player)\nand for open a PDA over App Icons";		
		end;
	elseif int == 3 then --backup XML
		local index = 1;
		for name, _boolean in pairs(moGeneralSettings.backupSettings) do		
			lineCmdTable[index] = {};
			lineCmdTable[index].cmdTable = moGeneralSettings.backupSettings;
			lineCmdTable[index].cmdValue = tostring(name);
			lineCmdTable[index].cmdType = "boolean";		
			lineCmdTable[index].buttonTxt = name;
			lineCmdTable[index].buttonTxtAndCmd = true;
			lineCmdTable[index].isSelect = _boolean;		
			--lineCmdTable[_index].infoTxt = "";
			index = index+1;
		end;
	elseif int == 4 then --mohSLOTs is delete
		function comp(w1,w2)			
			if w1[1] < w2[1] then
				return true;
			end;			
		end;
		local mohSLOTs = moSetGetMohSLOT:getSLOTs();
		table.sort(mohSLOTs, comp);			
		for slot=1, #mohSLOTs do		
			lineCmdTable[slot] = {};
			lineCmdTable[slot].cmdTable = nil;
			lineCmdTable[slot].cmdValue = nil;
			lineCmdTable[slot].cmdType = "stringOnly";
			lineCmdTable[slot].buttonTxt = tostring(mohSLOTs[slot][2]);
			lineCmdTable[slot].modOnlyInfo = tostring(mohSLOTs[slot][1]);
			lineCmdTable[slot].isSelect = tostring(mohSLOTs[slot][1]) == "masterSLOT_";
			if tostring(mohSLOTs[slot][1]) == "masterSLOT_" then
				lineCmdTable[slot].infoTxt = "This Master Slot can not delete";
			else
				lineCmdTable[slot].infoTxt = "!! Warning !! Delete SLOT is irrevocable, with(incl.) all Cmd and Settings.";
			end;
		end;
	elseif int == 5 then --tabltSide3 Cmd List Select
		local cmdInt = 1;
		for a=1, #MultiOverlayV3.cmdTable do		
			for cmd=1, #MultiOverlayV3.cmdTable[a].cmd do
				if MultiOverlayV3.cmdTable[a].cmd[cmd].typ ~= "output_" then					
					lineCmdTable[cmdInt] = {};
					lineCmdTable[cmdInt].cmdTable = nil;
					lineCmdTable[cmdInt].cmdValue = nil;
					lineCmdTable[cmdInt].cmdType = "stringOnly";
					lineCmdTable[cmdInt].buttonTxt = tostring(MultiOverlayV3.cmdTable[a].cmd[cmd].displayName);		
					lineCmdTable[cmdInt].isSelect = false;					
					if isSelect ~= nil and isSelect == cmd then lineCmdTable[cmdInt].isSelect = true;end;					
					lineCmdTable[cmdInt].infoTxt = tostring(MultiOverlayV3.cmdTable[a].cmd[cmd].infoTxt);
					lineCmdTable[cmdInt].modOnlyInfo = {cmdTable=a, cmdPos=cmd};
					cmdInt = cmdInt+1;
				end;
			end;
		end;
	elseif int == 6 then --Color List Select
		local index = 1;	
		for name, _ in pairs(moColors.extern) do		
			lineCmdTable[index] = {};
			lineCmdTable[index].cmdTable = nil;
			lineCmdTable[index].cmdValue = nil;
			lineCmdTable[index].cmdType = "stringOnly";
			lineCmdTable[index].buttonTxt = tostring(name);
			lineCmdTable[index].isSelect = tostring(name) == colorName;
			index = index+1;
		end;
		local keys = {};
		local newSortTable = {};
		function sortTable(myTable)			
			for key, _ in pairs(myTable) do
				table.insert(keys, key);
			end
			table.sort(keys, function(keyLhs, keyRhs) return myTable[keyLhs].buttonTxt < myTable[keyRhs].buttonTxt end);
			for _, key in ipairs(keys) do
				table.insert(newSortTable, myTable[key]);
			end;
		end;
		sortTable(lineCmdTable);		
		lineCmdTable = newSortTable;	
	end;	
	return lineCmdTable;
end;

function moSetGetGuiMenue:setAppMouseSelectButtoTxt(whichPDA, deletePdaLine, deletePdaLineApp, newPdaLine, newPdaLineApp) --wird öfters benötigt deshalb extra
	local whichSubPDA = whichPDA or "masterPDA_";
	local defaultPageSide = nil; 
	local getThisButtonPage = nil;
	local guiPageTable = nil;
	
	--deletePdaLine_
	if deletePdaLine then
		defaultPageSide = 1  --ändern wenn die seite verschoben wird
		getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="deletePdaLine_", pageGlobalName=whichSubPDA} );
		if getThisButtonPage == nil then return;end;
		guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		if getThisButtonPage.slavePage ~= nil then guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].page[getThisButtonPage.slavePage].side[getThisButtonPage.pageSide];end
		guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button].buttonTxt = "Delete Select Line (".. tostring(moSetGetOverlays.pda[whichSubPDA].appMouseSelect.line).. ")";
	end;
	--deletePdaLine_	
	
	--deletePdaLineApp_
	if deletePdaLineApp then
		defaultPageSide = 1  --ändern wenn die seite verschoben wird
		getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="deletePdaLineApp_", pageGlobalName=whichSubPDA} );
		if getThisButtonPage == nil then return;end;
		guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		if getThisButtonPage.slavePage ~= nil then guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].page[getThisButtonPage.slavePage].side[getThisButtonPage.pageSide];end;	
		guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button].buttonTxt = "Delete Select App (".. tostring(moSetGetOverlays.pda[whichSubPDA].appMouseSelect.app).. ")";
	end;
	--deletePdaLineApp_	
	
	--newPdaLine_
	if newPdaLine then
		defaultPageSide = 1  --ändern wenn die seite verschoben wird
		getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="newPdaLine_", pageGlobalName=whichSubPDA} );
		if getThisButtonPage == nil then return;end;
		guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		if getThisButtonPage.slavePage ~= nil then guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].page[getThisButtonPage.slavePage].side[getThisButtonPage.pageSide];end
		local appsAtLine = moSetGetOverlays.pda[whichSubPDA].line[moSetGetMohPDA:getLineMouseSelect(whichSubPDA)].appsAtLine;
		guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button].buttonTxt = "PDA Lines Total(".. tostring(#moSetGetOverlays.pda[whichSubPDA].line).. ")";
	end;
	--newPdaLine_
	
	--newPdaLineApp_
	if newPdaLineApp then
		defaultPageSide = 1  --ändern wenn die seite verschoben wird
		getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="newPdaLineApp_", pageGlobalName=whichSubPDA} );
		if getThisButtonPage == nil then return;end;
		guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		if getThisButtonPage.slavePage ~= nil then guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].page[getThisButtonPage.slavePage].side[getThisButtonPage.pageSide];end
		local appsAtLine = moSetGetOverlays.pda[whichSubPDA].line[moSetGetMohPDA:getLineMouseSelect(whichSubPDA)].appsAtLine;
		guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button].buttonTxt = "PDA Line Apps Total(".. tostring(appsAtLine).. ")";		
	end;
	--newPdaLineApp_
	
	--openMarker
	defaultPageSide = 1  --ändern wenn die seite verschoben wird
	getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="pdaAppIconOpenMarker_", pageGlobalName=whichSubPDA} );
	if getThisButtonPage == nil then return;end;
	guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
	if getThisButtonPage.slavePage ~= nil then guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].page[getThisButtonPage.slavePage].side[getThisButtonPage.pageSide];end
	local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
	local isSelect, selectApp = moSetGetMohPDA:getAppMouseSelect(selectLine, whichSubPDA);
	if isSelect then
		guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button].cmdTable = moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp];
	end;
	--openMarker	
end;

function moSetGetGuiMenue:resetSelectPullDownLine(self, line, button, buttonSelectTable, selectLine, multiple, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_";		
	local buttonTable = buttonSelectTable;
	--if line ~= nil and button ~= nil then buttonTable = Utils.getNoNil(g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastPage].line[line].button[button], nil);end;
	if buttonTable ~= nil then	
		for a=1, #buttonTable.cmdTable do			
			if multiple == nil or not multiple then
				if buttonTable.cmdTable[a].isSelect and a ~= selectLine then				
					buttonTable.cmdTable[a].isSelect = false;				
				elseif a == selectLine then 
					buttonTable.cmdTable[a].isSelect = true;
				end;
			elseif type(selectLine) == "table" and #selectLine > 0 then
				buttonTable.cmdTable[a].isSelect = selectLine[a];
			end;
		end;
	end;
end;

function moSetGetGuiMenue:getSelectPullDownLine(self, line, button, buttonSelectTable, multiple, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_";
	local selectPullDownLine = nil;
	if multiple ~= nil and multiple then selectPullDownLine = {};else selectPullDownLine=0;end;
	local buttonTable = buttonSelectTable;
	--if line ~= nil and button ~= nil then buttonTable = Utils.getNoNil(g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastPage].line[line].button[button], nil);end;
	if buttonTable ~= nil then	
		for a=1, #buttonTable.cmdTable do			
			if multiple == nil or not multiple then
				if buttonTable.cmdTable[a].isSelect then					
					selectPullDownLine = a;
				end;	
			else
				table.insert(selectPullDownLine, buttonTable.cmdTable[a].isSelect);
			end;
		end;
	end;
	return selectPullDownLine;
end;

function moSetGetGuiMenue:refreshAllSideCmdPullDownLine()
	--! Attention ! Fix Side 3 ändern wenn verschoben wird
	local defaultPageSide = 3;
	local mohPDAs = moSetGetMohPDA:getPDAs();	
	for pda=1, #mohPDAs do
		local whichSubPDA = mohPDAs[pda][1];
		for cmd=1, moGeneralSettings.maxCmd do
			local appCmdButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="appCmd".. tostring(cmd).. "_", pageGlobalName=whichSubPDA} );
			if appCmdButtonPage ~= nil and appCmdButtonPage.masterPage ~= nil and appCmdButtonPage.slavePage ~= nil and appCmdButtonPage.pageSide ~= nil then
				local appCmdGuiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[appCmdButtonPage.masterPage].page[appCmdButtonPage.slavePage].side[appCmdButtonPage.pageSide];	
				local appCmdButtonTable = Utils.getNoNil(appCmdGuiPageTable.line[appCmdButtonPage.line].button[appCmdButtonPage.button], nil);
				appCmdButtonTable.cmdTable = moSetGetGuiMenue:getNewPullDownTable(5, 1, whichSubPDA); --refresh cmd list uptodate
			end;				
		end;
	end;	
end;

function moSetGetGuiMenue:generateNewPdaName()
	local modAppValues = {
		dialogTitel=tostring(MultiOverlayV3.metadata.title), 
		dialogText2="Generate New PDA Name",		
		onSaveCallback=moSetGetGuiMenue.saveNewPdaName,
		checkText = {alreadyExistsTable=moSetGetOverlays.pdaNamen.suggestion, alreadyExistsAllow=false, inputTextAppendEnd="", maxLengthText=25, minLengthText=4},
		visibleButton = {saveButton=true, checkButton=true, checkButtonText="Check New PDA Name"}
	};
	return g_currentMission.guiMenue.guiSetGet:openLsOrGuiMenueDialog("GuiMenueInOutPutTextDialog", modAppValues);
end;

function moSetGetGuiMenue.saveNewPdaName(...)	
	local defaultPageSide = 1; --ändern wenn die seite verschoben wird
	if ... ~= nil and type(...) == "table" then
		local args = ...;				
		if args.inputText ~= nil then
			table.insert(moSetGetOverlays.pdaNamen.suggestion, 4, args.inputText);
			local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="globalPdaSelectName_"} );			
			if getThisButtonPage == nil then return;end;
			local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
			if getThisButtonPage.slavePage ~= nil then guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].page[getThisButtonPage.slavePage].side[getThisButtonPage.pageSide];end;			
			local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
			if buttonTable ~= nil then
				buttonTable.cmdTable = moSetGetGuiMenue:getNewPullDownTable(2);
			end;
		end;		
	end;	
end;

function moSetGetGuiMenue:getRandomName(namenList, typName)
	local namenList = namenList; --moSetGetOverlays.pdaNamen.getRandom;
	local typName = typName;
	local tableTyp = string.lower(typName);
	local randomName = "";
	local randomGlobalName = "";
	local isGenerate = false
	local random_number = 1;	
	function getRandomName()				
		local nameTemp = namenList[math.random(#namenList)];
		local name = tostring(nameTemp).. " ".. tostring(typName).. " ".. tostring(random_number);			
		local globalName = string.lower(tostring(nameTemp)).. tostring(random_number).. tostring(typName) .. "_";		
		return name, globalName;
	end;	
	while string.len(randomGlobalName) <= 0 do
		local name, globalName = getRandomName();						
		if moSetGetOverlays[tableTyp][globalName] == nil then		
			randomName = name;
			randomGlobalName = globalName;
		end;
		random_number = random_number+1;			
	end;	
	return randomName, randomGlobalName;
end;

function moSetGetGuiMenue:randomPdaName()
	local chars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
	local length = 10;
	local randomString = '';

	math.randomseed(os.time());

	charTable = {};
	for c in chars:gmatch"." do
		table.insert(charTable, c);
	end;

	for i = 1, length do
		randomString = randomString .. charTable[math.random(1, #charTable)];
	end;
	--print(randomString)
	return randomString;
end;