moStoragesConfig = {};

function moStoragesConfig:onStartMission()	
	moStorages:loadStorages();
end;

function moStoragesConfig:defaultValues()
	moStorages.values = {storages={}, updateTimer=10, msec=true};
end;

function moStoragesConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex)
	if moStorages.values == nil then moStoragesConfig:defaultValues();end;
	local groupNameTag = (xmlNameTag.. ".module.storages(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		moStorages.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	end;
	if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		moStorages.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	end;
end;

function moStoragesConfig:saveXml(self, Xml, xmlNameTag)
	if moStorages.values == nil then moStoragesConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.storages(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moStorages.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moStorages.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moStoragesConfig.onSaveCallback()
	moSetGetClientSettings:saveConfig(self)
end;