actionOpenCloseCmds = {};

--needs module not
--lineType max 2/actionOpenCloseCmds
function actionOpenCloseCmds:load(cmdName, cmdValues)	
	local lineTable = {lineTyp=1, txtScroll={leftRight=true,upDown=true}};
	if cmdValues ~= nil and cmdValues[1] == "openCloseCmds" then
		local cmdTable = cmdValues[5];
		local cmdPos = cmdValues[6];
		local cmdAction = cmdValues[7];
		lineTable[#lineTable+1] = {};
		local isLineTable = lineTable[#lineTable];
		isLineTable.ownValues = {cmdName, cmdTable, cmdPos, cmdAction};
		isLineTable.txt = {};			
		isLineTable.txt[1] = {};
		isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
		isLineTable.txt[1].bold = moModule.values.txtBold;
		isLineTable.txt[1].txt = tostring(MultiOverlayV3.cmdTable[cmdTable].cmd[cmdPos].displayName);
		isLineTable.txt[1].clickCallback = actionOpenCloseCmds.returnClickActionOpenCloseCmd;
		local buttonColor = moColors.intern["green"];
		isLineTable.txt[1].settingsButtonR = {"buttonRight", buttonColor, actionOpenCloseCmds.returnClickActionOpenCloseCmd};		
	end;	
	actionOpenCloseCmds[cmdName] = {output=lineTable};
end;

--index args 1=mouseClickLeft/mouseClickMiddle/mouseClickRight, args 2=cmdTablePos, args 3=cmdPos, args 4=clickAreaTable
function actionOpenCloseCmds.returnClickActionOpenCloseCmd(...)
	if ... ~= nil then
		local args = ...;
		if args.line ~= nil and args.ownValues ~= nil then
			local cmdAction = args.ownValues[4];
			if cmdAction ~= nil and type(cmdAction) == "function" then
				cmdAction("mouseButtonLeft", args.ownValues[2], args.ownValues[3], args.ownValues);
			else
				g_currentMission:showBlinkingWarning("Open/Close Cmd not found (deleted ?)", 2500);
			end;
		end;
	end;
end;	

function actionOpenCloseCmds.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;		
		if args.ownValues ~= nil and args.ownValues[4] ~= nil then
			local cmdName = args.ownValues[4];
			actionOpenCloseCmds:load(cmdName, args.ownValues);
			return actionOpenCloseCmds[cmdName].output;
		end;		
	end;
end;

function actionOpenCloseCmds.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--actionOpenCloseCmds:load();	
end;

function actionOpenCloseCmds:generateCmd()
	local _, errorTable = 0, {};
	function insertCmd(cmdTable, cmdPos, cmdName, displayName, cmdAction)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		newCmdTable.cmdTable[1] = {
			cmdName = cmdName;
			displayName = displayName;		
			multiple = true;
			sortBy = "Open/Close Cmds(by Moh)";
			infoTxt = "Zeigt alle Action Open/Close Cmds an";
			helpTxt = "Action Open/Close Cmd List";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;
			typ = "output";
			action = actionOpenCloseCmds.giveOutputTable; --a function
			ownValues = {"openCloseCmds", nil, nil, cmdName, cmdTable, cmdPos, cmdAction}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);	
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate actionOpenCloseCmds Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;	
	if MultiOverlayV3.cmdTable[MultiOverlayV3.ownCmdTable] ~= nil then
		for cmd=1, #MultiOverlayV3.cmdTable[MultiOverlayV3.ownCmdTable].cmd do
			local isCmd = MultiOverlayV3.cmdTable[MultiOverlayV3.ownCmdTable].cmd[cmd];
			if isCmd ~= nil and isCmd.typ == "action_" then
				if string.find(isCmd.name, "openClose") then
					insertCmd(MultiOverlayV3.ownCmdTable, cmd, isCmd.name, isCmd.displayName, isCmd.action);
				end;
			end;
		end;
	end;		
end;